<?php

/**
 * Implementation of hook_contentblocker_data().
 */
function user_contentblocker_data() {
  return array(
    'user' => array(
      'type_title' => t('Users'),
      'title_table' => 'users',
      'title_table_alias' => 'u',
      'title_field' => 'name',
      'title_id_field' => 'uid',
      'title_path_prefix' => 'user',
      'block_table' => 'node',
      'block_field' => 'uid',
      'primary_table' => 'users',
      'primary_table_alias' => 'u',
      'primary_id_field' => 'uid',
      'primary_join_field' => 'uid',
      'node_field' => 'uid',
    ),
  );
}

/**
 * Implementation of hook_contentblocker_options().
 */
function user_contentblocker_options($obj_type, $obj) {
  global $user;

  switch ($obj_type) {
    case 'node':
      $return = array();
      // Don't allow block of user's own content.
      if ($obj->uid != $user->uid) {
        $return['user'] = array(
          t('Block content by @name', array('@name' => $obj->name)),
          t('Unblock content by @name', array('@name' => $obj->name)),
        );
      }
      return $return;
  }
}

/**
 * Implementation of hook_user().
 *
 * Add togglable links to user pages.
 */
/** Commented out, the link is not yet implemented, maybe move to a patch on fasttoggle.
function contentblocker_user($type, &$edit, &$this_user) {
  global $user;
  // Users can't block themselves.
  if ($type == 'view' && $user->uid && $user->uid != $this_user->uid && user_access(_contentblocker_get_perm('user'))) {
    // Because 'user' is not one of the types accepted in hook_link(), we generate
    // a set of links following the hook_links() approach and rendering with the
    // theme function applied to e.g. node links.
    $items = array();
    $items['contentblocker'] = array(
      'title' => '',
      'value' => theme('links', contentblocker_get_links('user', $this_user), array('class' => 'links inline')),
      'class' => 'contentblocker',
    ); 
    return array(t('Settings') => $items); 
  }
}
*/